/* jquery.jkun.tabbrowse.js */
/* Home : http://www.jkun.net
 * Email : jkun.net@gmail.com
 */

function iframeResize(frameID) {
	var $f = $('#' + frameID);
	var h = $f.parent().css('min-height');
	h = (parseInt(h) < 1 || h == undefined || h == null) ? $f.parent().height() : h;
	$f.parent().height( h );
}

var tabBrowser = function(options) {
	this.init(options);
};
tabBrowser.prototype = {
	init : function(options) {
		this.browserElement = '#' + $('*[data-widget="tabBrowser"]').attr('id');//options.browserElement;
		this.useConfirm = options.useConfirm;
		this.appendTabsLink = options.appendTabsLink;
		this.appendIdRule = options.appendIdRule;
		this.appendLimit = options.appendLimit;
		this.duplicateCheck = options.duplicateCheck;
		this.displayView();
		this.removeControlAppend();
		this.bindRemoveEvent();
		this.appendTabs();

		$(this.browserElement).find('div.viewer').find('div[class!="active"]').hide();
	},
	// appendTabsLink : this.appendTabsLink,
	browserElement : this.browserElement,
	useConfirm : this.useConfirm,
	appendIdRule : this.appendIdRule,
	appendLimit : this.appendLimit,
	duplicateCheck : this.duplicateCheck,
	displayView : function() {
		var $this = this;
		$(document).on('click', $this.browserElement + ' ul.controller a', function() {
			$($this.browserElement + ' ul.controller a').removeClass('selected');
			$(this).addClass('selected');
			$($this.browserElement).find('div.viewer').find('div').removeClass('active');
			var viewID = $(this).attr('href');
			$(viewID).addClass('active');
		});
	},
	removeControlAppend : function() {
		var $this = this;
		var $controls = $($this.browserElement).find('ul.controller');
		$.each($controls, function() {
			$(this).find('li').append('<button type="button" data-control-id="'+ $(this).find('a').attr('href') +'">X</button>');
		});
	},
	bindRemoveEvent : function() {
		var $this = this;
		var $controls = $($this.browserElement).find('ul.controller');

		$(document).on('click', $this.browserElement + ' ul.controller button', function() {
			console.log($(this).parent());
			if ($this.useConfirm) {
				var txt = $(this).parent().find('a').text();
				if (confirm('이 탭['+ txt +'] 을 삭제하시겠습니까?')) {
					$(this).parent().fadeOut(600, function() { $(this).remove() });
					$(this).attr('data-control-id').fadeOut(600, function() { $(this).remove(); });
				}
			} else {
				$(this).parent().fadeOut(600, function(){
					$(this).remove();
				});
				$($(this).attr('data-control-id')).fadeOut(600, function(){
					$(this).remove();
				});
				// $controls.parents('li').fadeOut(600, function() { $(this).remove() });
				// $(this).attr('data-control-id').fadeOut(600, function() { $(this).remove(); });
			}
		});
	},
	appendTabs : function() {
		var $this = this;
		var addControlsSelector = '*[data-tabs-append-control="true"]';
		var addControls = $(addControlsSelector);

		$(document).on('click', addControlsSelector,function() {
			var viewSync = $(this).attr('data-view-sync');
			var viewSyncUrl = $(this).attr('data-view-sync-url');

			var seq = $($this.browserElement).find('ul.controller li').length + 1;

			if (parseInt($this.appendLimit) <= parseInt(seq - 1)) {
				return false;
			}

			var tabsText = $(this).text();
			if ($this.duplicateCheck) {
				var isDuplicateTab = $this.isDuplicateCheck(tabsText);
				if (isDuplicateTab) {
					if (confirm('동일한 탭이 존재합니다. 지우고 새로 불러오시겠습니까?')) {
						$($this.browserElement).find('ul.controller li a').each(function() {
							if ($(this).text() == tabsText) {
								var vid = $(this).attr('href');
								$(this).parent().remove();
								$(vid).remove();
								return false;
							}
						});
					} else {
						return false;
					}
				}
			}

			// setTimeout(function() {
				//Controller
				$($this.browserElement).find('ul.controller li a').removeClass('selected');
				$($this.browserElement).find('ul.controller').append('<li><a href="#'+ $this.appendIdRule + seq +'">'+ tabsText +'</a><button type="button" data-control-id="#'+ $this.appendIdRule + seq +'">X</button></li>');
				$($this.browserElement).find('ul.controller li:last a').addClass('selected');

				//Viewer
				var viewSyncContent = '';
				if (viewSync == 'iframe') {
					var frameHeight = parseInt($('div.viewer div').css('min-height'));
					viewSyncContent = '<iframe name="TAB_BROWSE_SYNC_VIEW_FRAME'+ seq +'" id="TAB_BROWSE_SYNC_VIEW_FRAME'+ seq +'" src="'+ viewSyncUrl +'" width="100%" height="100%" scrolling="yes" frameborder="0" onload="iframeResize(this.id)"></iframe>';
				} else if (viewSync == 'ajax') {
					var jqxhr = $.ajax({
							url : viewSyncUrl,
							async : false,
							cache : false,
							processData : false,
							dataType : 'text'
						})
						.done(function(c) {
							viewSyncContent = c;
							console.log('Done!');

						})
						.fail(function() {
							alert( 'Error!' );
						})
						.always(function() {
							console.log('xhr Connect!');
					});
						console.log(viewSyncContent);
				}

				$($this.browserElement).find('div.viewer div').removeClass('active');
				$($this.browserElement).find('div.viewer').append('<div id="'+ $this.appendIdRule + seq +'" style="display:none;" class="active">'+ viewSyncContent +'</div>');
			// }, 500);
		});
	},
	isDuplicateCheck : function (tabsText) {
		var result = false;
		var $this = this;
		$($this.browserElement).find('ul.controller li a').each(function() {
			if ($(this).text() == tabsText) {
				result = true;
				return false;
			}
		});
		return result;
	}
};